//
//  FaceView.m
//  ThinkCode
//
//  Created by liwh on 12-1-5.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import "FaceView.h"


@implementation FaceView
@synthesize scale = _scale;
@synthesize dataSource = _dataSource;

#define DEFAULT_SCALE  0.90

-(CGFloat)scale
{
    if (!_scale) {
        return DEFAULT_SCALE;
    }else{
        return _scale;
    }
    return _scale;
}

-(void)setScale:(CGFloat)scale 
{
    if (_scale != scale) {
        _scale = scale;
        [self  setNeedsDisplay]; //redraw view
    }
}

-(void)pinch:(UIPinchGestureRecognizer *)gesture
{
    if ((gesture.state == UIGestureRecognizerStateChanged) ||
        (gesture.state == UIGestureRecognizerStateEnded)) {
        self.scale *= gesture.scale;
        gesture.scale = 1;
    }
}

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    return self;
}

-(void)drawCircleAtPoint:(CGPoint)p withRadius:(CGFloat)radius inContext:(CGContextRef)context
{
    UIGraphicsPushContext(context);
    CGContextBeginPath(context);
    CGContextAddArc(context, p.x, p.y, radius, 0, 2*M_PI, YES);
    CGContextStrokePath(context);
    UIGraphicsPopContext();
}

// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
    CGContextRef context = UIGraphicsGetCurrentContext();
    // draw face
    CGPoint midPoint;
    midPoint.x = self.bounds.origin.x + self.bounds.size.width / 2 ;
    midPoint.y = self.bounds.origin.y + self.bounds.size.height / 2 ;
    CGFloat size = self.bounds.size.width / 2; 
    if (self.bounds.size.height < self.bounds.size.width) size = self.bounds.size.height / 2 ;
    size *= self.scale;
    
    CGContextSetLineWidth(context, 5.0);
    [[UIColor redColor] setStroke];
    [self drawCircleAtPoint:midPoint withRadius:size inContext:context];
    
    //draw eyes
#define EYE_H 0.35
#define EYE_V 0.35
#define EYE_RADIUS 0.10
    CGPoint eyePoint;
    eyePoint.x = midPoint.x - size * EYE_H;
    eyePoint.y = midPoint.y - size * EYE_V;
    
    [self drawCircleAtPoint:eyePoint withRadius:size * EYE_RADIUS inContext:context];
    eyePoint.x += size * EYE_H * 2;
    [self drawCircleAtPoint:eyePoint withRadius:size * EYE_RADIUS inContext:context];
    
    
#define MOUTH_H 0.45
#define MOUTH_V 0.40
#define MOUTH_SMILE 0.25
    
    //no nose
    CGPoint mouthStart;
    mouthStart.x = midPoint.x - MOUTH_H * size ;
    mouthStart.y = midPoint.y + MOUTH_H * size ;
    CGPoint mouthEnd = mouthStart;
    mouthEnd.x += MOUTH_H * size * 2;
    CGPoint mouthCP1 = mouthStart ;
    mouthCP1.x += MOUTH_H * size * 2/3;
    CGPoint mouthCP2 = mouthEnd ;
    mouthCP1.x -= MOUTH_H * size * 2/3;
    
    float smile = [self.dataSource smileForFaceView:self];
    if (smile < -1)  smile = -1;
    if (smile > 1)  smile = 1;
    CGFloat smileOffset = MOUTH_SMILE * size * smile;
    mouthCP1.y += smileOffset;
    mouthCP2.y += smileOffset;
    
    CGContextBeginPath(context);
    CGContextMoveToPoint(context, mouthStart.x, mouthStart.y);
    CGContextAddCurveToPoint(context, mouthCP1.x, mouthCP2.y, mouthCP2.x, mouthCP2.y, mouthEnd.x, mouthEnd.y);
    CGContextStrokePath(context);
    // draw mouth
}

@end
