//
//  ViewController.m
//  ThinkCode
//
//  Created by liwh on 12-1-5.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"
#import "FaceView.h"

@interface ViewController() <FaceViewDataSource>
@property(nonatomic,weak) IBOutlet FaceView *faceview;
@end

@implementation ViewController
@synthesize faceview = _faceview;
@synthesize happiness = _happiness;

-(void)setHappiness:(float)happiness
{
    _happiness = happiness;
    [self.faceview setNeedsDisplay];
}

-(void)setFaceview:(FaceView *)faceview
{
    _faceview = faceview;
    UIPinchGestureRecognizer *reg = [[UIPinchGestureRecognizer alloc] initWithTarget:_faceview action:@selector(pinch:)];
    [self.faceview addGestureRecognizer:reg];
    [self.faceview addGestureRecognizer:[[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(handleHappinessGesture:)]];
    self.faceview.dataSource = self;
}

-(void)handleHappinessGesture: (UIPanGestureRecognizer *) gesture
{
    if ((gesture.state == UIGestureRecognizerStateChanged) ||
        (gesture.state == UIGestureRecognizerStateEnded)) {
        CGPoint t = [gesture translationInView:self.faceview];
        self.happiness -= t.y / 2;
        [gesture setTranslation:CGPointZero inView:self.faceview];
    }
}
-(float)smileForFaceView:(FaceView *)sender
{
    return (self.happiness - 50)/ 50.0;
}

-(BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation
{
    return YES;
}
@end
